Get deployment settings by ID
GET /api
Also reachable at /api, /api.
Path Parameters
projectIdstring (required)
The Project ID to get the deployment settings from. ExampleProjects-1.spaceIdstring (required)
Response
200 — The requested Deployment Settings.
CancelQueuedTasksbooleanCancelRunningTasksbooleanConnectivityPolicyobjectAllowDeploymentsToNoTargetsbooleanExcludeUnhealthyTargetsbooleanSkipMachineBehaviorenum
Allowed values:None,SkipUnavailableMachines.TargetRolesarray of string
DefaultGuidedFailureModeenum
Allowed values:EnvironmentDefault,Off,On.DefaultToSkipIfAlreadyInstalledbooleanDeploymentChangesTemplatestringFailTargetDiscoverybooleanForcePackageDownloadbooleanIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.ProjectIdstringReleaseNotesTemplatestringSpaceIdstringVersioningStrategyobjectDonorPackageobjectTemplatestring
Example Response
{
"CancelQueuedTasks": true,
"CancelRunningTasks": true,
"ConnectivityPolicy": {
"AllowDeploymentsToNoTargets": true,
"ExcludeUnhealthyTargets": true,
"SkipMachineBehavior": "None",
"TargetRoles": [
"string"
]
},
"DefaultGuidedFailureMode": "EnvironmentDefault",
"DefaultToSkipIfAlreadyInstalled": true,
"DeploymentChangesTemplate": "string",
"FailTargetDiscovery": true,
"ForcePackageDownload": true,
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"ProjectId": "Projects-1",
"ReleaseNotesTemplate": "string",
"SpaceId": "Spaces-1",
"VersioningStrategy": {
"DonorPackage": {
"DeploymentAction": "string",
"PackageReference": "string"
},
"Template": "string"
}
}Get deployment settings by ID
GET /api
Also reachable at /api, /api.
Path Parameters
gitRefstring (required)projectIdstring (required)
The Project ID to get the deployment settings from. ExampleProjects-1.spaceIdstring (required)
Response
200 — The requested Deployment Settings.
CancelQueuedTasksbooleanCancelRunningTasksbooleanConnectivityPolicyobjectAllowDeploymentsToNoTargetsbooleanExcludeUnhealthyTargetsbooleanSkipMachineBehaviorenum
Allowed values:None,SkipUnavailableMachines.TargetRolesarray of string
DefaultGuidedFailureModeenum
Allowed values:EnvironmentDefault,Off,On.DefaultToSkipIfAlreadyInstalledbooleanDeploymentChangesTemplatestringFailTargetDiscoverybooleanForcePackageDownloadbooleanIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.ProjectIdstringReleaseNotesTemplatestringSpaceIdstringVersioningStrategyobjectDonorPackageobjectTemplatestring
Example Response
{
"CancelQueuedTasks": true,
"CancelRunningTasks": true,
"ConnectivityPolicy": {
"AllowDeploymentsToNoTargets": true,
"ExcludeUnhealthyTargets": true,
"SkipMachineBehavior": "None",
"TargetRoles": [
"string"
]
},
"DefaultGuidedFailureMode": "EnvironmentDefault",
"DefaultToSkipIfAlreadyInstalled": true,
"DeploymentChangesTemplate": "string",
"FailTargetDiscovery": true,
"ForcePackageDownload": true,
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"ProjectId": "Projects-1",
"ReleaseNotesTemplate": "string",
"SpaceId": "Spaces-1",
"VersioningStrategy": {
"DonorPackage": {
"DeploymentAction": "string",
"PackageReference": "string"
},
"Template": "string"
}
}Modify deployment settings
PUT /api
Also reachable at /api, /api.
Modifies deployment settings for a project.
Path Parameters
gitRefstring (required)
Git reference to use when modifying deployment settings.projectIdstring (required)
The Project ID to get the deployment settings from. ExampleProjects-1.spaceIdstring (required)
The ID of the space containing the resource(s).
Request Body
CancelQueuedTasksboolean
When enabled, creating a new deployment will cancel all previously queued deployments to the same project/environment/tenant.CancelRunningTasksboolean
When enabled, completing a deployment will cancel older running or paused deployments to the same project/environment/tenant.ChangeDescriptionstring
Used as the Git commit message. Omit to use the default message ‘Update deployment settings’.ConnectivityPolicyobjectAllowDeploymentsToNoTargetsbooleanExcludeUnhealthyTargetsbooleanSkipMachineBehaviorenum
Allowed values:None,SkipUnavailableMachines.TargetRolesarray of string
DefaultGuidedFailureModeenum
The action related to when a deployment error occurs. (IE: Enabling guided failure will pause the deployment failure to allow error correction before proceeding).
Allowed values:EnvironmentDefault,Off,On.DefaultToSkipIfAlreadyInstalledboolean
If true, and the version of the package being deployed is already present on the machine, its re-deployment will be skipped.DeploymentChangesTemplatestring
A markdown template generated for each deployment’s changes.FailTargetDiscoveryboolean
Option to fail a step if no matching targets found in cloud discovery steps.ForcePackageDownloadboolean
Option to force re-downloading packages for deployment.GitRefstring (required)
Git reference to use when modifying deployment settings.ProjectIdstring (required)
The Project ID to get the deployment settings from. ExampleProjects-1.ReleaseNotesTemplatestring
Template text pre-filled as the release notes when a release of this project is created; may contain Octopus variable expressions. Omitting this clears the project’s existing template.SpaceIdstring (required)
The ID of the space containing the resource(s).VersioningStrategyobjectDonorPackageobjectTemplatestring
Response
200 — Confirmation that the Deployment Settings were modified, contains the updated Deployment Settings
CancelQueuedTasksbooleanCancelRunningTasksbooleanConnectivityPolicyobjectAllowDeploymentsToNoTargetsbooleanExcludeUnhealthyTargetsbooleanSkipMachineBehaviorenum
Allowed values:None,SkipUnavailableMachines.TargetRolesarray of string
DefaultGuidedFailureModeenum
Allowed values:EnvironmentDefault,Off,On.DefaultToSkipIfAlreadyInstalledbooleanDeploymentChangesTemplatestringFailTargetDiscoverybooleanForcePackageDownloadbooleanIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.ProjectIdstringReleaseNotesTemplatestringSpaceIdstringVersioningStrategyobjectDonorPackageobjectTemplatestring
Example Request
{
"CancelQueuedTasks": true,
"CancelRunningTasks": true,
"ChangeDescription": "string",
"ConnectivityPolicy": {
"AllowDeploymentsToNoTargets": true,
"ExcludeUnhealthyTargets": true,
"SkipMachineBehavior": "None",
"TargetRoles": [
"string"
]
},
"DefaultGuidedFailureMode": "EnvironmentDefault",
"DefaultToSkipIfAlreadyInstalled": true,
"DeploymentChangesTemplate": "string",
"FailTargetDiscovery": true,
"ForcePackageDownload": true,
"GitRef": "string",
"ProjectId": "Projects-1",
"ReleaseNotesTemplate": "string",
"SpaceId": "Spaces-1",
"VersioningStrategy": {
"DonorPackage": {
"DeploymentAction": "string",
"PackageReference": "string"
},
"Template": "string"
}
}Example Response
{
"CancelQueuedTasks": true,
"CancelRunningTasks": true,
"ConnectivityPolicy": {
"AllowDeploymentsToNoTargets": true,
"ExcludeUnhealthyTargets": true,
"SkipMachineBehavior": "None",
"TargetRoles": [
"string"
]
},
"DefaultGuidedFailureMode": "EnvironmentDefault",
"DefaultToSkipIfAlreadyInstalled": true,
"DeploymentChangesTemplate": "string",
"FailTargetDiscovery": true,
"ForcePackageDownload": true,
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"ProjectId": "Projects-1",
"ReleaseNotesTemplate": "string",
"SpaceId": "Spaces-1",
"VersioningStrategy": {
"DonorPackage": {
"DeploymentAction": "string",
"PackageReference": "string"
},
"Template": "string"
}
}Get deployment settings by ID
GET /api
Also reachable at /api, /api.
Deprecated. This endpoint may be removed in a future release.
Path Parameters
idstring (required)
ID of the DeploymentSettings to load.spaceIdstring (required)
Response
200 — Success
CancelQueuedTasksbooleanCancelRunningTasksbooleanConnectivityPolicyobjectAllowDeploymentsToNoTargetsbooleanExcludeUnhealthyTargetsbooleanSkipMachineBehaviorenum
Allowed values:None,SkipUnavailableMachines.TargetRolesarray of string
DefaultGuidedFailureModeenum
Allowed values:EnvironmentDefault,Off,On.DefaultToSkipIfAlreadyInstalledbooleanDeploymentChangesTemplatestringFailTargetDiscoverybooleanForcePackageDownloadbooleanIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.ProjectIdstringReleaseNotesTemplatestringSpaceIdstringVersioningStrategyobjectDonorPackageobjectTemplatestring
Example Response
{
"CancelQueuedTasks": true,
"CancelRunningTasks": true,
"ConnectivityPolicy": {
"AllowDeploymentsToNoTargets": true,
"ExcludeUnhealthyTargets": true,
"SkipMachineBehavior": "None",
"TargetRoles": [
"string"
]
},
"DefaultGuidedFailureMode": "EnvironmentDefault",
"DefaultToSkipIfAlreadyInstalled": true,
"DeploymentChangesTemplate": "string",
"FailTargetDiscovery": true,
"ForcePackageDownload": true,
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"ProjectId": "Projects-1",
"ReleaseNotesTemplate": "string",
"SpaceId": "Spaces-1",
"VersioningStrategy": {
"DonorPackage": {
"DeploymentAction": "string",
"PackageReference": "string"
},
"Template": "string"
}
}Modify deployment settings
PUT /api
Also reachable at /api, /api, /api, /api, /api.
Deprecated. This endpoint may be removed in a future release.
Modifies deployment settings for a project.
Path Parameters
projectIdstring (required)
The Project ID to get the deployment settings from. ExampleProjects-1.spaceIdstring (required)
The ID of the space containing the resource(s).
Request Body
CancelQueuedTasksboolean
When enabled, creating a new deployment will cancel all previously queued deployments to the same project/environment/tenant.CancelRunningTasksboolean
When enabled, completing a deployment will cancel older running or paused deployments to the same project/environment/tenant.ChangeDescriptionstring
The description for the deployment settings modification.ConnectivityPolicyobjectAllowDeploymentsToNoTargetsbooleanExcludeUnhealthyTargetsbooleanSkipMachineBehaviorenum
Allowed values:None,SkipUnavailableMachines.TargetRolesarray of string
DefaultGuidedFailureModeenum
The action related to when a deployment error occurs. (IE: Enabling guided failure will pause the deployment failure to allow error correction before proceeding).
Allowed values:EnvironmentDefault,Off,On.DefaultToSkipIfAlreadyInstalledboolean
If true, and the version of the package being deployed is already present on the machine, its re-deployment will be skipped.DeploymentChangesTemplatestring
A markdown template generated for each deployment’s changes.FailTargetDiscoveryboolean
Fail cloud discovery steps if no targets found.ForcePackageDownloadboolean
Option to force re-downloading packages for deployment.ProjectIdstring (required)
The Project ID to get the deployment settings from. ExampleProjects-1.ReleaseNotesTemplatestring
Template text pre-filled as the release notes when a release of this project is created; may contain Octopus variable expressions. Omitting this clears the project’s existing template.SpaceIdstring (required)
The ID of the space containing the resource(s).VersioningStrategyobjectDonorPackageobjectTemplatestring
Response
200 — Confirmation that the Deployment Settings were modified, contains the updated Deployment Settings
CancelQueuedTasksbooleanCancelRunningTasksbooleanConnectivityPolicyobjectAllowDeploymentsToNoTargetsbooleanExcludeUnhealthyTargetsbooleanSkipMachineBehaviorenum
Allowed values:None,SkipUnavailableMachines.TargetRolesarray of string
DefaultGuidedFailureModeenum
Allowed values:EnvironmentDefault,Off,On.DefaultToSkipIfAlreadyInstalledbooleanDeploymentChangesTemplatestringFailTargetDiscoverybooleanForcePackageDownloadbooleanIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.ProjectIdstringReleaseNotesTemplatestringSpaceIdstringVersioningStrategyobjectDonorPackageobjectTemplatestring
Example Request
{
"CancelQueuedTasks": true,
"CancelRunningTasks": true,
"ChangeDescription": "string",
"ConnectivityPolicy": {
"AllowDeploymentsToNoTargets": true,
"ExcludeUnhealthyTargets": true,
"SkipMachineBehavior": "None",
"TargetRoles": [
"string"
]
},
"DefaultGuidedFailureMode": "EnvironmentDefault",
"DefaultToSkipIfAlreadyInstalled": true,
"DeploymentChangesTemplate": "string",
"FailTargetDiscovery": true,
"ForcePackageDownload": true,
"ProjectId": "Projects-1",
"ReleaseNotesTemplate": "string",
"SpaceId": "Spaces-1",
"VersioningStrategy": {
"DonorPackage": {
"DeploymentAction": "string",
"PackageReference": "string"
},
"Template": "string"
}
}Example Response
{
"CancelQueuedTasks": true,
"CancelRunningTasks": true,
"ConnectivityPolicy": {
"AllowDeploymentsToNoTargets": true,
"ExcludeUnhealthyTargets": true,
"SkipMachineBehavior": "None",
"TargetRoles": [
"string"
]
},
"DefaultGuidedFailureMode": "EnvironmentDefault",
"DefaultToSkipIfAlreadyInstalled": true,
"DeploymentChangesTemplate": "string",
"FailTargetDiscovery": true,
"ForcePackageDownload": true,
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"ProjectId": "Projects-1",
"ReleaseNotesTemplate": "string",
"SpaceId": "Spaces-1",
"VersioningStrategy": {
"DonorPackage": {
"DeploymentAction": "string",
"PackageReference": "string"
},
"Template": "string"
}
}